//
// Miscellaneous Building Blocks: Comparator, DataMux
//
`include "cache.h"
`include "stdbus.h"

module Comparator (Tag1, Tag2, Match);

input   [`TAG]  Tag1;
input   [`TAG]  Tag2;
output          Match;

wire            Match = Tag1 == Tag2;

//always @ (Tag1 or Tag2) begin
//   #1 $display($time, " Tag1 %d   Tag2 %d   Match %b", Tag1, Tag2, Match);
//end
endmodule /* Comparator */


module DataMux (S, A, B, Z);

input           S;      // Select line
input   [`DATA] A;      // A input bus
input   [`DATA] B;      // B input bus
output  [`DATA] Z;      // output bus

wire    [`DATA] Z = S ? A : B;

endmodule /* DataMux */

module AddrMux (S, A, B, Z);

input           S;      // Select line
input   [`ADDR] A;      // A input bus
input   [`ADDR] B;      // B input bus
output  [`ADDR] Z;      // output bus

wire    [`ADDR] Z = S ? A : B;

endmodule /* AddrMux */

module TriStateBuffer (in, out, enable);

input	[`DATA] in;
input		enable;
output	[`DATA] out;

wire	[`DATA] out = enable ? in : `DATAWIDTH'bz;

endmodule /* TriStateBuffer */